
#define   ConfPin_0          11
#define   ConfPin_1          12

#define   RelayCount         7
#define   MODE_TRIGGER       0
#define   MODE_HOLD          1
#define   MODE_ONLY_ONE_ON   2


uint8_t RelayPins[] = {0, 1, 2, 3, 4, 5, 6, };
uint8_t KeyPins[] = {7, A0, A1, A2, A3, A4, A5, };

void setup()
{
  for(uint8_t i = 0; i < RelayCount; i++)
  {
    digitalWrite(KeyPins[i], HIGH);
    pinMode(RelayPins[i], OUTPUT);
  }

  digitalWrite(ConfPin_0, HIGH);
  digitalWrite(ConfPin_1, HIGH);

  uint8_t Mode = (digitalRead(ConfPin_1) << 1) | digitalRead(ConfPin_0);

  void (*Modes[])(void) = { Mode_0, Mode_1, Mode_2, };

  (*Modes[Mode])();
}

void loop()
{
  
}
//----------------------
void Mode_0()
{
  for(;;)
  {
    for(uint8_t i = 0; i < RelayCount; i++)
    {
      if (digitalRead(KeyPins[i]) == 0)
      {
        delay(70);
        if (digitalRead(KeyPins[i]) == 0)
        {
          if (digitalRead(RelayPins[i]) == 0)
            digitalWrite(RelayPins[i], HIGH);
          else
            digitalWrite(RelayPins[i], LOW);

          while(digitalRead(KeyPins[i]) == 0);
        }
      }
    }
  }
}
//----------------------
void Mode_1()
{
  for(;;)
  {
    for(uint8_t i = 0; i < RelayCount; i++)
    {
      if (digitalRead(KeyPins[i]) == 0)
        digitalWrite(RelayPins[i], HIGH);
      else
        digitalWrite(RelayPins[i], LOW);
    }
  }
}
//----------------------
void Mode_2()
{
  for(;;)
  {
    for(uint8_t i = 0; i < RelayCount; i++)
    {
      if (digitalRead(KeyPins[i]) == 0)
      {
        delay(70);
        if (digitalRead(KeyPins[i]) == 0)
        {
          for(uint8_t j = 0; j < RelayCount; j++)
            digitalWrite(RelayPins[j], LOW);

          digitalWrite(RelayPins[i], HIGH);
          while(digitalRead(KeyPins[i]) == 0);
        }
      }
    }
  }
}



